-- #######################################
-- #######################################
--       GOH DEATH KNIGHT EVENT LOG
-- #######################################
-- #######################################

function GoH_DeathKnight.events.PLAYER_ENTERING_WORLD()
	-- print("Hello World.");
	GoH5_DeathKnight_SavedVariables();
	GoH_Settings_Set_Menu_Button_Images();
	GoH_DeathKnight_Set_Menu_Button_Images();
	doSavedVariable_Plugin_Check();
end

function GoH_DeathKnight.events.COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceFlags2, destGUID, destName, destFlags, destFlags2, ...)

  -- ###########################################################################################################
  -- SINCE THESE ARE LOCAL, YOU CAN RE-USE THE SAME NAMES IN OTHER GOH CLASS MODS AND DON'T HAVE TO CHANGE THEM.
  -- ###########################################################################################################
  local GoH_spellID, GoH_spellName, GoH_all_spellSchool, GoH_amount, GoH_overkill, GoH_school, GoH_resisted, GoH_blocked, GoH_absorbed, GoH_critical = ...

	-- CHECK THE TIMER
	if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == nil then
		GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "YES";
	end

-- HEALTH HEALME EMOTE
if GoHv5_DeathKnight_Data.config.Use_Health_Warning == "YES" then
	if GoHv5_DeathKnight_Data.config.Use_Health_Warning_Emote == "YES"  then
		if GoHv5_DeathKnight_Data.config.Use_Health_Warning_Emote_Shown == "NO" then
			if ((UnitHealth("player") / UnitHealthMax("player")) <= (GoHv5_DeathKnight_Data.config.Health_Percentage)) then
			   DoEmote("healme");
			   GoHv5_DeathKnight_Data.config.Use_Health_Warning_Emote_Shown = "YES";
			end
		end
		if ((UnitHealth("player") / UnitHealthMax("player")) >= (GoHv5_DeathKnight_Data.config.Health_Percentage+0.05)) then
		   GoHv5_DeathKnight_Data.config.Use_Health_Warning_Emote_Shown = "NO";
		end
	end
end

-- MANA OOM EMOTE
if GoHv5_DeathKnight_Data.config.Use_Mana_Warning == "YES" then
	if GoHv5_DeathKnight_Data.config.Use_Mana_Warning_Emote == "YES"  then
		if GoHv5_DeathKnight_Data.config.Use_Mana_Warning_Emote_Shown == "NO" then
			if ((UnitMana("player") / UnitManaMax("player")) <= (GoHv5_DeathKnight_Data.config.Mana_Percentage)) then
			   DoEmote("oom");
			   GoHv5_DeathKnight_Data.config.Use_Mana_Warning_Emote_Shown = "YES";
			end
		end
		if ((UnitMana("player") / UnitManaMax("player")) >= (GoHv5_DeathKnight_Data.config.Mana_Percentage+0.05)) then
		   GoHv5_DeathKnight_Data.config.Use_Mana_Warning_Emote_Shown = "NO";
		end
	end
end

	-- ################################################################
	-- ################################################################
	-- ################################################################
	-- ################################################################
	-- ################################################################
	-- ################################################################
	-- ################################################################
	-- BEGIN DEATHKNIGHT SPELLS
	-- ################################################################

	if (GoH_DeathKnight.Class == "DEATHKNIGHT") then -- BEGIN CLASS CHECK

		-- DEATH KNIGHT: DEATH GRIP
		if GoHv5_DeathKnight_Data.config.Death_Grip == "YES" then
			if (GoH_spellID == 49576) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_DEATHGRIP_Sound();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: HORN OF WINTER
		if GoHv5_DeathKnight_Data.config.Horn_of_Winter == "YES" then
			if (GoH_spellID == 57330) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				-- HORN OF WINTER HAS BEEN CASTED
				GoHv5_DeathKnight_Data.config.Horn_of_Winter_Casted = "YES";

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\HornOfWinter_Begins_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: DEATH AND DECAY
		if GoHv5_DeathKnight_Data.config.Death_and_Decay == "YES" then
			if (GoH_spellID == 43265) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\StealthDetected_Sonar.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: PESTILENCE
		if GoHv5_DeathKnight_Data.config.Pestilence == "YES" then
			if (GoH_spellID == 50842) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\I_See_You_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: OUTBREAK
		if GoHv5_DeathKnight_Data.config.Outbreak == "YES" then
			if (GoH_spellID == 77575) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Thats_Enough_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: BLOOD TAP
		if GoHv5_DeathKnight_Data.config.Blood_Tap == "YES" then
			if (GoH_spellID == 45529) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Sound\\Creature\\CThun\\CThunYouWillDie.Wav","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: DEATH COIL
		if GoHv5_DeathKnight_Data.config.Death_Coil == "YES" then
			if (GoH_spellID == 47541) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Death_Coil.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: EMPOWER RUNE WEAPON
		if GoHv5_DeathKnight_Data.config.Empower_Rune_Weapon == "YES" then
			if (GoH_spellID == 47568) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Sound\\Creature\\LichKing\\IC_Lich King_FMAttack01.wav","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: ICEBOUND FORTITUDE
		if GoHv5_DeathKnight_Data.config.Icebound_Fortitude == "YES" then
			if (GoH_spellID == 48792) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\IceboundFortitude_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: BLOOD PRESENCE
		if GoHv5_DeathKnight_Data.config.Blood_Presence == "YES" then
			if (GoH_spellID == 48263) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Blood_Craze_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: FROST PRESENCE
		if GoHv5_DeathKnight_Data.config.Frost_Presence == "YES" then
			if (GoH_spellID == 48266) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\FreezingFog_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: UNHOLY PRESENCE
		if GoHv5_DeathKnight_Data.config.Unholy_Presence == "YES" then
			if (GoH_spellID == 48265) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\HolyPower_1.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: ANTI-MAGIC SHELL
		if GoHv5_DeathKnight_Data.config.AntiMagic_Shell == "YES" then
			if (GoH_spellID == 48707) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Camouflage.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			 -- DEATH KNIGHT: ANTI-MAGIC ZONE
		if GoHv5_DeathKnight_Data.config.AntiMagic_Zone == "YES" then
			if (GoH_spellID == 51052) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Get_Under_Here_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		-- DEATH KNIGHT: RAISE ALLY
		if GoHv5_DeathKnight_Data.config.Raise_Ally == "YES" then
			if (GoH_spellID == 61999) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\RaiseAlly_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		-- DEATH KNIGHT: (RAISE ALLY) VOID TOUCH DEBUFF
		if GoHv5_DeathKnight_Data.config.Void_Touch_Debuff == "YES" then
			if (GoH_spellID == 97821) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\RaiseAlly_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: RAISE DEAD
		if GoHv5_DeathKnight_Data.config.Raise_Dead == "YES" then
			if (GoH_spellName == DeathKnight_Raise_Dead_Name) and (event == "SPELL_SUMMON") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\RaiseDead_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: ARMY OF THE DEAD
		if GoHv5_DeathKnight_Data.config.Army_of_the_Dead == "YES" then
			if (GoH_spellID == 42650) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\ArmyoftheDead2_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: SUMMON GARGOYLE
		if GoHv5_DeathKnight_Data.config.Summon_Gargoyle == "YES" then
			if (GoH_spellID == 49206) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\SummonGargoyle_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: DEATH PACT
		if GoHv5_DeathKnight_Data.config.Death_Pact == "YES" then
			if (GoH_spellID == 48743) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Death_Pact_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: DARK TRANSFORMATION
		if GoHv5_DeathKnight_Data.config.Dark_Transformation == "YES" then
			if (GoH_spellID == 63560) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Dark_Transformation_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: STRANGULATE
		if GoHv5_DeathKnight_Data.config.Strangulate == "YES" then
			if (GoH_spellID == 47476) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Sound\\Creature\\Illidan\\BLACK_Illidan_04.wav","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: MIND FREEZE
		if GoHv5_DeathKnight_Data.config.Mind_Freeze == "YES" then
			if (GoH_spellID == 47528) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Sound\\Creature\\Illidan\\BLACK_Illidan_04.wav","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: UNHOLY FRENZY
		if GoHv5_DeathKnight_Data.config.Unholy_Frenzy == "YES" then
			if (GoH_spellID == 49016) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Slaughter_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: BLOOD BOIL
		if GoHv5_DeathKnight_Data.config.Blood_Boil == "YES" then
			if (GoH_spellID == 48721) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Toasty_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			 -- DEATH KNIGHT: DARK COMMAND
		if GoHv5_DeathKnight_Data.config.Dark_Command == "YES" then
			if (GoH_spellID == 56222) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_DEATHGRIP_Sound();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			 -- DEATH KNIGHT: BONE SHIELD
		if GoHv5_DeathKnight_Data.config.Bone_Shield == "YES" then
			if (GoH_spellID == 49222) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\BoneShield_Begins_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: UNHOLY BLIGHT
		if GoHv5_DeathKnight_Data.config.Unholy_Blight == "YES" then
			if (GoH_spellID == 115989) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\ArmyoftheDead_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		   -- DEATH KNIGHT: CHAINS OF ICE
		if GoHv5_DeathKnight_Data.config.Chains_of_Ice == "YES" then
			if (GoH_spellID == 45524) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		   -- DEATH KNIGHT: DARK SIMULATION
		if GoHv5_DeathKnight_Data.config.Dark_Simulation == "YES" then
			if (GoH_spellID == 77606) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\All_Too_Easy_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		   -- DEATH KNIGHT: ICY TOUCH
		if GoHv5_DeathKnight_Data.config.Icy_Touch == "YES" then
			if (GoH_spellID == 45477) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Critical_1.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		   -- DEATH KNIGHT: PATH OF FROST
		if GoHv5_DeathKnight_Data.config.Path_of_Frost == "YES" then
			if (GoH_spellID == 3714) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Death_Coil_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		   -- DEATH KNIGHT: DANCING RUNE WEAPON
		if GoHv5_DeathKnight_Data.config.Dancing_Rune_Weapon == "YES" then
			if (GoH_spellID == 49028) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		   -- DEATH KNIGHT: REMORSELESS WINTER
		if GoHv5_DeathKnight_Data.config.Remorseless_Winter == "YES" then
			if (GoH_spellID == 108200) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\FreezingFog_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		   -- DEATH KNIGHT: ASPHYXIATE
		if GoHv5_DeathKnight_Data.config.Asphyxiate == "YES" then
			if (GoH_spellID == 108194) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Cower_Before_Me_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: DEATHS ADVANCE
		if GoHv5_DeathKnight_Data.config.Deaths_Advance == "YES" then
			if (GoH_spellID == 96268) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Sound\\Creature\\Illidan\\BLACK_Illidan_04.wav","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

			-- DEATH KNIGHT: GORFIENDS GRASP
		if GoHv5_DeathKnight_Data.config.Gorfiends_Grasp == "YES" then
			if (GoH_spellID == 108199) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_DEATHGRIP_Sound();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

		-- DEATH KNIGHT: DEATH GATE
		if GoHv5_DeathKnight_Data.config.Death_Gate == "YES" then
			if (GoH_spellName == DeathKnight_Death_Gate_Name) and (event == "SPELL_CAST_START") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Stargate.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

	end -- END DEATH KNIGHT CLASS CHECK

        -- DEATH KNIGHT: CONTROL DEAD
		if GoHv5_DeathKnight_Data.config.Control_Undead == "YES" then
			if (GoH_spellName == DeathKnight_Control_Undead_Name) and (event == "SPELL_CAST_START") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\ArmyoftheDead_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: RUNE TAP
		if GoHv5_DeathKnight_Data.config.Rune_Tap == "YES" then
			if (GoH_spellID == 48982) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: PLAGUE LEECH
		if GoHv5_DeathKnight_Data.config.Plague_Leech == "YES" then
			if (GoH_spellID == 123693) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: Lichborne
		if GoHv5_DeathKnight_Data.config.Lichborne == "YES" then
			if (GoH_spellID == 49039) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: DESECRATED GROUND
		if GoHv5_DeathKnight_Data.config.Desecrated_Ground == "YES" then
			if (GoH_spellID == 108201) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

        -- DEATH KNIGHT: VAMPIRIC BLOOD
		if GoHv5_DeathKnight_Data.config.Vampiric_Blood == "YES" then
			if (GoH_spellID == 55233) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Heartbeat.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end



	-- #######################################################################
	-- #######################################################################
	-- #######################################################################
	-- #######################################################################
	-- #######################################################################
	-- BEGIN RACIALS
	-- #######################################################################

	   -- HUMAN RACIAL: EVERY MAN FOR HIMSELF
	if GoHv5_DeathKnight_Data.config.Every_Man_For_Himself == "YES" then
		if GoH_DeathKnight.Race == "Human" then
			if (GoH_spellID == 59752) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\You_Are_Nothing_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

		-- NIGHTELF RACIAL: -- SHADOWMELD
	if GoHv5_DeathKnight_Data.config.NightElf_Racial_Shadowmeld == "YES" then
		if GoH_DeathKnight.Race == "NightElf" then
			if (GoH_spellID == 58984) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Camouflage.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- WOGEN RACIAL: TWO FORMS
	if GoHv5_DeathKnight_Data.config.Worgen_Two_Forms_Racial == "YES" then
		if GoH_DeathKnight.Race == "Worgen" then
			if (GoH_spellID == 68996) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- GNOME RACIAL: ESCAPE ARTIST
	if GoHv5_DeathKnight_Data.config.Gnome_Escape_Artist_Racial == "YES" then
		if GoH_DeathKnight.Race == "Gnome" then
			if (GoH_spellID == 20589) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- DRAENEI RACIAL: GIFT OF THE NAARU
	if GoHv5_DeathKnight_Data.config.Draenei_Gift_Racial == "YES" then
		if GoH_DeathKnight.Race == "Draenei" then
			if (GoH_spellName == Draenei_Gift_of_the_Naaru_Name) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\HolyPower_1.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- PANDAREN RACIAL: QUAKING PALM
	if GoHv5_DeathKnight_Data.config.Pandaren_Quaking_Palm_Racial == "YES" then
		if GoH_DeathKnight.Race == "Pandaren" then
			if (GoH_spellID == 107079) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Woooaaaoo.mp3","Master");

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- BLOOD ELF RACIAL: ARCANE TORRENT
	if GoHv5_DeathKnight_Data.config.BloodElf_Arcane_Torrent_Racial == "YES" then
		if (GoH_DeathKnight.Race == "BloodElf") or (GoH_DeathKnight.Race == "Blood Elf") then
			if (GoH_spellName == BloodElf_Arcane_Torrent_Name) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- GOBLIN RACIAL: ROCKET JUMP
	if GoHv5_DeathKnight_Data.config.Goblin_Rocket_Jump_Racial == "YES" then
		if GoH_DeathKnight.Race == "Goblin" then
			if (GoH_spellID == 69070) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- ORC RACIAL: BLOOD FURY
	if GoHv5_DeathKnight_Data.config.Orc_Blood_Fury_Racial == "YES" then
		if GoH_DeathKnight.Race == "Orc" then
			if (GoH_spellName == Orc_Blood_Fury_Name) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- TROLL RACIAL: BERSERKING
	if GoHv5_DeathKnight_Data.config.Troll_Berserking_Racial == "YES" then
		if GoH_DeathKnight.Race == "Troll" then
			if (GoH_spellID == 26297) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- UNDEAD RACIAL: WILL OF THE FORSAKEN
	if GoHv5_DeathKnight_Data.config.Undead_Will_of_the_Forsaken_Racial == "YES" then
		if (GoH_DeathKnight.Race == "Undead") or (GoH_DeathKnight.Race == "Forsaken") or (GoH_DeathKnight.Race == "Scourge") then
			if (GoH_spellID == 7744) and (event == "SPELL_CAST_SUCCESS") and (sourceName == GoH_DeathKnight.CharName)then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

end



-- #######################################
-- #######################################
-- UNIT SPELLCAST SUCCEEDED
-- #######################################
-- #######################################
function GoH_DeathKnight.events.UNIT_SPELLCAST_SUCCEEDED(caster, GoH_spellName, arg2, arg3, GoH_spellID, arg5, ...)


	   -- DWARF RACIAL: STONEFORM
	if GoHv5_DeathKnight_Data.config.Dwarve_Stoneform_Racial == "YES" then
		if GoH_DeathKnight.Race == "Dwarf" then
			if (GoH_spellName == Dwarve_Stoneform_Name) and (caster == "player")then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end

	   -- TAUREN RACIAL: WAR STOMP
	if GoHv5_DeathKnight_Data.config.Tauren_War_Stomp_Racial == "YES" then
		if GoH_DeathKnight.Race == "Tauren" then
			if (GoH_spellName == Tauren_War_Stomp_Name) and (caster == "player")then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					Play_Random_Laugh();

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end
	end


	if (GoH_DeathKnight.Class == "DEATHKNIGHT") then -- BEGIN CLASS CHECK

		-- DEATH KNIGHT: ACHERUS DEATHCHARGER
		if GoHv5_DeathKnight_Data.config.Acherus_Deathcharger == "YES" then
			if (GoH_spellName == DeathKnight_Acherus_Deathcharger_Name) and (caster == "player")then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Summon_Mount_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- DO YOUR EMOTE
					if GoHv5_DeathKnight_Data.config.Acherus_Deathcharger_UseName == "YES" then
						if GoH_DeathKnight.Gender == "Female" then
								SendChatMessage("summons " .. GoHv5_DeathKnight_Data.config.Acherus_Deathcharger_CustomName .. ", her trusty " .. GetSpellLink(DeathKnight_Acherus_Deathcharger_ID) .. ".", "EMOTE");
						else
								SendChatMessage("summons " .. GoHv5_DeathKnight_Data.config.Acherus_Deathcharger_CustomName .. ", his trusty " .. GetSpellLink(DeathKnight_Acherus_Deathcharger_ID) .. ".", "EMOTE");
						end
					end

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end

			end
		end

		-- DEATH KNIGHT: WINGED STEED OF THE EBON BLADE
		if GoHv5_DeathKnight_Data.config.Winged_Steed_of_the_Ebon_Blade == "YES" then
			if (GoH_spellName == DeathKnight_Winged_Steed_Name) and (caster == "player")then

				if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

					-- PLAY YOUR SOUND
					PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Summon_Mount_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

					-- DO YOUR EMOTE
					if GoHv5_DeathKnight_Data.config.Winged_Steed_of_the_Ebon_Blade_UseName == "YES" then
						if GoH_DeathKnight.Gender == "Female" then
								SendChatMessage("summons " .. GoHv5_DeathKnight_Data.config.Winged_Steed_of_the_Ebon_Blade_CustomName .. ", her trusty " .. GetSpellLink(DeathKnight_Winged_Steed_ID) .. ".", "EMOTE");
						else
								SendChatMessage("summons " .. GoHv5_DeathKnight_Data.config.Winged_Steed_of_the_Ebon_Blade_CustomName .. ", his trusty " .. GetSpellLink(DeathKnight_Winged_Steed_ID) .. ".", "EMOTE");
						end
					end

					-- RESET THE TIMER
					GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
					-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

				end
			end
		end

	end -- END DEATH KNIGHT CLASS CHECK
end




-- #######################################
-- #######################################
-- PLAYER ENTER COMBAT SOUNDS
-- #######################################
-- #######################################
function GoH_DeathKnight.events.PLAYER_REGEN_DISABLED()

	if GoHv5_DeathKnight_Data.config.Menu_Fight_Sound == "YES" then

			if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

				-- PLAY YOUR SOUND
				PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Fight_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

				-- RESET THE TIMER
				GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
				-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

			end
	end

		-- #######################################
		-- #######################################

		if GoHv5_DeathKnight_Data.config.Menu_Fight_Music == "YES" then

					-- PLAY FIGHTING MUSIC
						-- CALL RANDOM MATH GENERATOR
						GoH_DeathKnight.NumberRandom = math.random(10);

						-- USE RANDOM MATH GENERATED RESULT

						if (GoH_DeathKnight.NumberRandom == 1) then

							PlayMusic("Interface\\AddOns\\GoH\\Music\\Mortal Kombat beatbox remix by MrWonderspyder.mp3");

						elseif (GoH_DeathKnight.NumberRandom ~= 1) then

							PlayRandomCombatMusic();

						end

		end

		-- #######################################
		-- #######################################

end

function PlayRandomCombatMusic()

					-- PLAY RANDOM FIGHTING MUSIC
						-- CALL RANDOM MATH GENERATOR
						GoH_DeathKnight.NumberRandom = math.random(9);

						-- USE RANDOM MATH GENERATED RESULT

						if (GoH_DeathKnight.NumberRandom == 1) then

							PlayMusic("Interface\\AddOns\\GoH\\Music\\Remixed_Mortal_Kombat_Theme.mp3");

						elseif (GoH_DeathKnight.NumberRandom == 2) then

							PlayMusic("Interface\\AddOns\\GoH\\Music\\Remixed_Scorpion_Theme.mp3");

						elseif (GoH_DeathKnight.NumberRandom == 3) then

							PlayMusic("Interface\\AddOns\\GoH\\Music\\Mortal Kombat remix by HybridTech.mp3");

						elseif (GoH_DeathKnight.NumberRandom == 4) then

							PlayMusic("Interface\\AddOns\\GoH\\Music\\Remixed_Mortal_Kombat_Theme.mp3");

						elseif (GoH_DeathKnight.NumberRandom == 5) then

							PlayMusic("Interface\\AddOns\\GoH\\Music\\Remixed_Scorpion_Theme.mp3");

						elseif (GoH_DeathKnight.NumberRandom == 6) then

							PlayMusic("Interface\\AddOns\\GoH\\Music\\Duel of the Fates Remix by ShinAkuma76.mp3");

						elseif (GoH_DeathKnight.NumberRandom == 7) then

							PlayMusic("Interface\\AddOns\\GoH\\Music\\mortal kombat theme by josephsherrill.mp3");

						elseif (GoH_DeathKnight.NumberRandom == 8) then

							PlayMusic("Interface\\AddOns\\GoH\\Music\\Remixed_Mortal_Kombat_Theme.mp3");

						elseif (GoH_DeathKnight.NumberRandom == 9) then

							PlayMusic("Interface\\AddOns\\GoH\\Music\\Remixed_Scorpion_Theme.mp3");

						end

end

-- #######################################
-- #######################################
-- PLAYER LEAVE COMBAT SOUNDS
-- #######################################
-- #######################################
function GoH_DeathKnight.events.PLAYER_REGEN_ENABLED()

	if GoHv5_DeathKnight_Data.config.Menu_Fatality_Sound == "YES" then

			if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

				-- PLAY YOUR SOUND
				PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\Fatality_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

				-- RESET THE TIMER
				GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
				-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

			end
	end


		-- #######################################
		-- #######################################

		if GoHv5_DeathKnight_Data.config.Menu_Fight_Music == "YES" then

			-- STOP FIGHTING MUSIC
				StopMusic();
		end

		-- #######################################
		-- #######################################
end


function GoH_DeathKnight.events.PLAYER_LOGIN()

			local playerClass, EngClass = UnitClass("player");
			GoH_DeathKnight.Class = EngClass;
			GoHv5_DeathKnight_Data.config.LoggedInAsClass = GoH_DeathKnight.Class;
			-- print(GoHv5_DeathKnight_Data.config.LoggedInAsClass)


			if (GoH_DeathKnight.Class == "DEATHKNIGHT") then
				if GoHv5_DeathKnight_Data.config.Stupid_Login_Sound == "YES"then

					if GoHv5_DeathKnight_Data.config.GoH_Timer_Ready == "YES" then

						-- PLAY YOUR SOUND
						PlaySoundFile("Sound\\Creature\\LichKing\\EH_LichKing_Irritated1.wav","Master");

						-- RESET THE TIMER
						GoHv5_DeathKnight_Data.config.GoH_Timer_Ready = "NO"; GoHv5_DeathKnight_Data.config.GoH_Timer_Time = 0;
						-- print(GoHv5_DeathKnight_Data.config.GoH_Timer_Ready);

					end
				end
			end
end


function do_HornOfWinter_Reminder()

		if GoHv5_DeathKnight_Data.config.Horn_of_Winter_Ends == "YES" then -- BEGIN HoW Ended CHECK
			if GoHv5_DeathKnight_Data.config.Horn_of_Winter_Casted == "YES" then -- BEGIN HoW Casted
				if (GoH_DeathKnight.Class == "DEATHKNIGHT") then -- BEGIN CLASS CHECK

					if UnitAura("player", DeathKnight_Horn_of_Winter_Name) then -- BEGIN AURA CHECK
						-- DO NOTHING AS HORN OF WINTER IS STILL PRESENT.

					else -- ELSE AURA CHECK

						-- SET HORN OF WINTER CAST TRACKER BACK TO NO.
						GoHv5_DeathKnight_Data.config.Horn_of_Winter_Casted = "NO";

						-- IF HORN OF WINTER IS NOT PRESENT, THEN REMINDER YOU!
						PlaySoundFile("Interface\\AddOns\\GoH_DeathKnight\\Sounds\\HornOfWinter_Ends_" .. GoH_DeathKnight.Gender .. ".mp3","Master");

						-- DISPLAY AN ERROR FRAME MESSAGE TOO.
						UIErrorsFrame:AddMessage(DeathKnight_Horn_of_Winter_Name .. " is no longer active.", 1, 1, 0);

					end -- END AURA CHECK
				end -- END CLASS CHECK
			end -- END HoW Casted
		end -- END HoW Ended CHECK

end
